#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_ITENS    200

#define TAM_ARQNOME  128
#define TAM_NOME      41
#define TAM_END      121
#define TAM_FONE      16
#define TAM_EMAIL     21
#define TAM_CIDADE    11
#define TAM_CEP       10
#define TAM_ESTADO     4
#define TAM_NIVER     10

struct endereco {
  char nome[TAM_NOME];
  char end[TAM_END];
  char fone[TAM_FONE];
  char email[TAM_EMAIL];
  char cidade[TAM_CIDADE];
  char cep[TAM_CEP];
  char estado[TAM_ESTADO];
  char niver[TAM_NIVER];
};


/* Le um item da agenda */
struct endereco leItem ()
{

  struct endereco item = {"", "", "", "", "", "", "", "1/2/2009"};

  /* Obtem os dados de um item da agenda */
  printf("NOME: ");
  fgets(item.nome, TAM_NOME, stdin);

  if (strlen(item.nome) != 1) {
    printf("ENDERECO: ");
    fgets(item.end, TAM_END, stdin);
    
    printf("FONE: ");
    fgets(item.fone, TAM_FONE, stdin);
    
    printf("E-MAIL: ");
    fgets(item.email, TAM_EMAIL, stdin);
    
    printf("CIDADE: ");
    fgets(item.cidade, TAM_CIDADE, stdin);
    
    printf("ESTADO: ");
    fgets(item.estado, TAM_ESTADO, stdin);
    
    printf("CEP: ");
    fgets(item.cep, TAM_CEP, stdin);

    printf("\n\n%%%%%%%%%%%%%%%%%%%%%%\n\n");
  }

  return item;
}


int main ()
{

  struct endereco agenda[MAX_ITENS],
                  ragenda[MAX_ITENS];
  char arquivo[] = "agenda.dat";
  int nitens;
  FILE *fp;
 
  fp = fopen (arquivo, "w");
  
  if (fp == NULL)
    printf("Erro ao abrir arquivo %s\n", arquivo);
  else {
    nitens = 0;
    do {
      agenda[nitens] = leItem();
    } while (strlen(agenda[nitens++].nome) != 1);
    
    --nitens;
    
    printf("\n\nGravando agenda no arquivo \"%s\" .... ", arquivo);
    
    if (fwrite(agenda, sizeof(struct endereco), nitens, fp) != nitens)
      printf("Erro na gravacao da agenda !!!!!\n\n");
    else
      printf("OK!!!!\n\n");
      
    fclose(fp);     /* fecha arquivo */
  }  /* FIM (fp == NULL) */
}

